* PACKAGE DADMN  !" ϳ ᥤѡ
*"                  ver 1.00                   92/11/16 takepiro
**********************************************************************
      SUBROUTINE DYNMCS                      !"  ϳز
     M         ( GAU   , GAV   , GAW   , GAT   , 
     M           GATOR , GAPOR , 
     I           IT    , DELT  , OADVNC,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
*"      Runge-Kutta ʬ( ʿڥȥ - ľåɶ )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      INTEGER    IT                          !" ̤
      REAL       DELT                        !" ֹߦt
      LOGICAL    OADVNC                      !" 郎ʹԤ뤫ݤ
*"       :  ѿ
*
*   [INPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KDIM )              !" ٥()
      REAL       DRAD  ( 0:KDIM )              !" ()
*"        : ɸʻ
*
*   [INTERNAL SAVE]
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
*   [INTERNAL PARAM]
      LOGICAL    ODIASP
c$$$      DATA       ODIASP         / .FALSE. /
      DATA       ODIASP         / .TRUE. /
      SAVE       ODIASP
*
*   [INTERNAL WORK]
      REAL       GTUA  ( IDIM, JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KDIM )  !" ľưѲ֣
      REAL       GTH   ( IDIM, JDIM, 0:KDIM )  !" ٻѲ  
*"       : ʻѲ­
*
      REAL       GTUT  ( IDIM, JDIM, 0:KDIM )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, 0:KDIM )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM, JDIM, 0:KDIM )  !" ٱľή  ף
*"       : Ѳ
*
      REAL       WDTOR ( NMDIM , 0:KDIM     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KDIM     )  !" ݥ 
      REAL       WDDPOR( NMDIM , 0:KDIM     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KDIM     )  !"   
      SAVE       WDTOR , WDPOR , WDDPOR, WDT
*"       : ڥȥǡ
*
      REAL       WTTOR ( NMDIM, 0:KDIM      )  !" ȥ 
      REAL       WTPOR ( NMDIM, 0:KDIM      )  !" ݥ 
      REAL       WTT   ( NMDIM, 0:KDIM      )  !"   
*"       : ڥȥѲ
*
      INTEGER    ITRUNG                        !" Runge-Kutta ѿ
      INTEGER    IORUNG                        !" Runge-Kutta 
      PARAMETER( IORUNG = 4 )
*
      integer m,l,k
*
*
*"  << SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    DPARM                     !" ѥ᥿
     O             ( RAYL , TAU  , PRND )
         CALL    DHSTRG                    !" 
*
         CALL GD2WD             !" ǡ򥹥ڥȥ
     O         ( WDTOR , WDPOR , WDT   , 
     I           GATOR , GAPOR , GAT      )
*
         CALL RESET ( WDDPOR, NMDIM*KMAX )
         CALL DLOPER
     M           ( WDDPOR, 
     I             WDPOR , 
     C             FLAPLA,
     C             ARAD  , DRAD    )
      ENDIF
*
*" << Runge-Kutta Loop >>
*
      ITRUNG = 0
*
 8888 CONTINUE                    !" <---  Runge-Kutta Loop : 
        ITRUNG = ITRUNG + 1 
*
*" << TNDNCY : Ѳ >>
*
c$$$        CALL GRDDYN             !"  ϳع
c$$$     O         ( GTUA  , GTVA  , GTWA  , 
c$$$     O           GTUT  , GTVT  , GTWT  , GTH   ,
c$$$     I           GAU   , GAV   , GAW   , GAT   ,
c$$$     C           UVFACT, FLAPLA, 
c$$$     C           ALAT  , DLAT  , ARAD  , DRAD    )
c$$$*
c$$$        CALL TENG2W             !" Ѳ򥹥ڥȥ
c$$$     O         ( WTTOR , WTPOR , WTT   , 
c$$$     I           GTUA  , GTVA  , GTWA  , 
c$$$     I           GTUT  , GTVT  , GTWT  , GTH , 
c$$$     C           FLAPLA,
c$$$     C           ARAD  , DRAD                  )
        CALL RESET( WTTOR, NMDIM*KMAX )
        CALL RESET( WTPOR, NMDIM*KMAX )
        CALL RESET( WTT  , NMDIM*KMAX )
*
        CALL LNDYN              !" ϳ 
     M         ( WTTOR , WTPOR , WTT   , 
     I           WDTOR , WDPOR , WDT   , WDDPOR, 
     C           RAYL  , TAU   , PRND  , 
     C           NMO   , FLAPLA, 
     C           ARAD  , DRAD                    )
*
      DO 111 K = 0, KDIM
      DO 111 M = 0, MMAX
         DO 111 L = 0, LMAX
            WRITE ( 6, * )  M,L
            if( nmo( 1,m,l) .ne. 0 )then
            WRITE ( 6, * ) 
     &      WDTOR( NMO(1,M,L), K ), WTTOR( NMO(1,M,L), K )
            WRITE ( 6, * ) 
     &      WDTOR( NMO(2,M,L), K ), WTTOR( NMO(2,M,L), K )
            endif
 111     CONTINUE 
*
*" << INTGR : ʬ >>
*
        CALL TINTGR             !" ڥȥʬ
     M         ( WDTOR , WDPOR , WDDPOR, WDT   , 
     I           WTTOR , WTPOR , WTT   , 
     I           DELT  , ITRUNG, 
     C           FLAPLA, 
     C           ARAD  , DRAD             )
*
        CALL GENGD              !" ʻͤ
     O         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     I           WDTOR , WDPOR , WDT   , 
     C           FLAPLA, UVFACT, 
     C           ARAD  , DRAD                    )
*
      IF ( ITRUNG . LT. IORUNG ) GOTO 8888  !" <--- Runge-Kutta Loop 
*
*" << OUTPUT :  >>
*
c$$$      CALL HISTIN ( GSIGD , 'SIGDOT')  !" ΰ
c$$$      CALL HISTIN ( GPID  , 'PIDOT' )
*
      CALL DDIAG                       !" 
     I         ( GAU   , GAV   , GAW   , GAT   , 
     C           PRND  , RAYL  , 
     C           ALAT  , ARAD                     )
*
      IF ( ODIASP ) THEN
        CALL SPCTLD                    !" ڥȥǤο
     I         ( WDTOR , 'TOR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDPOR , 'POR' , KMAX  , NMO   )
        CALL SPCTLD
     I         ( WDT   , 'TMP' , KMAX  , NMO   )
      ENDIF
*
      RETURN
*======================================================================
      ENTRY DSTRT                      !" ǡκ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     C           ALAT  , DLAT  , 
     C           ARAD  , DRAD                      )
*
*   [MODIFY]
*     REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
*     REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
*     REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
*     REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
*
*   [OUTNPUT]
*     REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
*     REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*
*   [INPUT]
*     REAL       ALAT  ( JDIM )              !" 
*     REAL       DLAT  ( JDIM )              !" ٲٽ
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
      CALL STRTV                       !" ǡ
     M         ( GAU   , GAV   , GAW   , GAT   , 
     O           GATOR , GAPOR ,
     C           FLAPLA, UVFACT,
     C           ARAD  , DRAD                     ) 
*
      RETURN
      END
***********************************************************************
      SUBROUTINE DHSTRG                !" ϳشطϤϿ
*
*   [INTERNAL PARAM]
      INTEGER    ISTYPL
      DATA       ISTYPL / 1 /
*
*   [INTERNAL WORK]
      REAL       VMISS
*
      CALL GZDBGT ( 'MISS' , VMISS )   !" »
*
c$$$      CALL HISTRG                      !" Ͽ
c$$$     I       ( 'UT', 'x-convective heat flux' ,'K m/s   ', 'AMLEV',
c$$$     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
c$$$     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
c$$$*
c$$$      CALL HISTRG
c$$$     I       ( 'VT', 'pi-tendency         ' ,'1/s   ', 'ASFC',
c$$$     I           VMISS , VMISS , VMISS , VMISS , ISTYPL  ,
c$$$     I         '   '   , '   ' , 0     , 0     , 'X'     ,'(1PE12.3)' )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  DPARM                 !" ѥ᥿
     O             ( RAYL , TAU  , PRND )
*
*   [OUTPUT]
      REAL       RAYL                          !" 쥤꡼
      REAL       TAU                           !" ƥ顼
      REAL       PRND                          !" ץɥ
*
*   [INTERNAL WORK]
      REAL       RAYLI                         !" 쥤꡼
      REAL       TAYLR                         !" ƥ顼
      REAL       PRNDL                         !" ץɥ
*
      NAMELIST    /NMDYN/  RAYLI, TAYLR, PRNDL
*
      INTEGER    IFPAR, JFPAR
*
*"         < 1. NAMELIST ɤ߹ >
*
      RAYLI = 0.
      TAYLR = 0.
      PRNDL = 1.0
*
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMDYN , END=1190 )
 1190 WRITE  ( JFPAR, NMDYN  )
*
      RAYL = RAYLI
      TAU  = SQRT( TAYLR )
      PRND = PRNDL
*
      RETURN
      END
