* PACKAGE DDIAG  !" ϳ  
*
*"  [HIS]  92/10/15(takepiro)
*
***********************************************************************
      SUBROUTINE DDIAG      !"  ǽ 
     I         ( GDU   , GDV   , GDW   , GDT   , 
     C           PRND  , RAYL  , 
     C           ALAT  , ARAD                     )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zccom.F"                    !" ɸʪ
*
*   [INPUT]
      REAL       GDU   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDV   ( IDIM, JDIM, KMAX )  !"   
      REAL       GDW   ( IDIM, JDIM, KMAX )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !"   
*
      REAL       RAYL                        !" 쥤꡼
      REAL       PRND                        !" ץɥ
*
      REAL       ALAT  ( JDIM )              !" 
      REAL       ARAD  ( KMAX )              !" ٥()
*
*   [INTERNAL WORK]
      COMMON    /COMWRK /
     &           GDKE  , GDIE  , GDTE  , GDAM
*
      REAL       GDKE  ( IDIM, JDIM, KMAX )  !" ưͥ륮
      REAL       GDIE  ( IDIM, JDIM, KMAX )  !" ͥ륮
      REAL       GDTE  ( IDIM, JDIM, KMAX )  !" ͥ륮
      REAL       GDAM  ( IDIM, JDIM, KMAX )  !" ѱư
*
      INTEGER    I,J,K

*    [INTERNAL ONCE]      
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*[ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL DDIHRG
      ENDIF
*
*"         < 1. ͥ륮ѱư >
*
      DO 1100 K = 1, KMAX
         DO 1100 I = 1, IMAX
            DO 1100 J = 1, JMAX
*
               GDKE ( I,J,K )
     &                = (   GDU( I,J,K )**2
     &                    + GDV( I,J,K )**2 
     &                    + GDW( I,J,K )**2   )/ 2.  
*
               GDIE ( I,J,K )
     &                = (   GDT( I,J,K )**2   )/ 2.
     &                  * PRND * RAYL
*
               GDTE ( I,J,K )
     &                = GDKE ( I,J,K ) + GDIE ( I,J,K )
*
               GDAM ( I,J,K )
     &                = GDU ( I,J,K ) 
     &                  * ARAD( K ) * COS( ALAT(J) )
*
 1100 CONTINUE
*
      CALL HISTIN ( GDKE  , 'KE'  )
      CALL HISTIN ( GDIE  , 'IE'  )
      CALL HISTIN ( GDTE  , 'TE'  )
      CALL HISTIN ( GDAM  , 'AM'  )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SPCTLD      !"  ڥȥ 
     I         ( WDATA , HTTL  , KDIMD , NMO   )
*
#ifdef SYS_IBMS
      INCLUDE (ZCDIM)                        !" ʻ, ȿ
#else
#include      "zcdim.F"                      !" ʻ, ȿ
#endif
*
*   [INPUT]
      INTEGER    KDIMD
      REAL       WDATA ( NMDIM, KDIMD )
      CHARACTER  HTTL  *(*)
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
*
*   [INTERNAL WORK]
      REAL       WAMP  ( 0:NMAX, KMAX+1 )
      LOGICAL    ODIAG
      INTEGER    JFLDIA, NCOLS, ISTR, IEND, IINT
      INTEGER    K,L,M,N
*
      CALL QDIAGP
     O     ( ODIAG , JFLDIA, NCOLS,
     O       ISTR  , IEND  , IINT ,
     I       KDIMD                  )
*
      IF ( .NOT. ODIAG )       RETURN
*
      CALL RESET ( WAMP, (NMAX+1)*KDIMD )
*
      DO 2100 K = 1, KDIMD
         DO 2110 N = 0 , NMAX
            DO 2120 M = 0 , MMAX, MINT
               L = N - M
               IF ( ( L .GE. 0 ).AND.( L .LE. LMAX ) ) THEN
                  WAMP ( N,K ) = WAMP ( N,K )
     &                         + WDATA( NMO(1,M,L),K ) ** 2
     &                         + WDATA( NMO(2,M,L),K ) ** 2
               ENDIF
 2120      CONTINUE
 2110   CONTINUE
 2100 CONTINUE
*
      WRITE ( JFLDIA, * ) '@@@@@@@@@@@@< SPECTRAL AMPLITUDE ', HTTL,
     &                    '>@@@@@@@@@@@@@'
*
      DO 3100 K = 1, KDIMD
         CALL PRINTD
     I       ( JFLDIA, '(1PE12.4)', WAMP  ,
     I         1     , NMAX+1 , 1     , K    ,
     I         NMAX+1, KDIMD  , NCOLS         )
 3100 CONTINUE
*
      RETURN
      END
